package com.my.model;

import java.util.ArrayList;
import java.util.List;

import com.my.utils.MyUtils;

/**分页model*/
public class CommonPage {

	//是否分页，否认true
	private boolean getPage = true;

	//起始页，默认1
	private Long startPage =1L;
	
	//每页数量，默认6
	private Long pageSize =6L;
	
	//当前表总数据
	private Long totalResult=0L;
	
	//根据当前总数据和当前每页数量分页
	private Long totalPage;
	
	//降序和升序，1:DESC：降序，从最新到最老，程序默认，其他：ASC：升序，从最老到最新，默认升序，即原始顺序
	private Integer  orderDirection  = 1;
	
	//"若未传递排序字段，暂定使用时间字段排序，但因为批量插入时时间雷同，因此替代成ID排序，由于存在第三方库不存在ID情况，删除默认值"
	private String sortFieldId;
	
	//"多字段排序，2021-09-22补充，原因是：他人公共表单类型查询时，将排序使用人")
	private List<String> sortFieldIdList;

	/**
	 * 获得sortFieldId
	 * @return String
	 */
	public String getSortFieldId() {
		return sortFieldId;
	}

	/**
	 * 设置sortFieldId
	 * @param sortFieldId
	 */
	public void setSortFieldId(String sortFieldId) {
		this.sortFieldId = sortFieldId;
	}

	public Long getStartPage() {
		return startPage;
	}

	public void setStartPage(Long startPage) {
		this.startPage = startPage;
	}

	public Long getPageSize() {
		return pageSize;
	}

	public void setPageSize(Long pageSize) {
		if(MyUtils.isNotNull(pageSize)) {
			this.pageSize = pageSize;
		}
	}

	public Long getTotalResult() {
		return totalResult;
	}

	public void setTotalResult(Long totalResult) {
		this.totalResult = totalResult;
	}

	public Long getTotalPage() {
		if(getTotalResult()%getPageSize()==0) {
			totalPage= getTotalResult()/getPageSize();
		}else {
			totalPage= getTotalResult()/getPageSize() +1;
		}
		return totalPage;
	}

	public void setTotalPage(Long totalPage) {
		this.totalPage = totalPage;
	}

	

	public boolean isGetPage() {
		return getPage;
	}

	public void setGetPage(boolean getPage) {
		this.getPage = getPage;
	}


	public List<String> getSortFieldIdList() {
		if(!MyUtils.isNotNull(sortFieldIdList)) {
			sortFieldIdList = new ArrayList<String>();
		}
		if(MyUtils.isNotNull(sortFieldId)) {
			sortFieldIdList.add(sortFieldId);
			sortFieldId = null;
		}
		return sortFieldIdList;
	}

	public void setSortFieldIdList(List<String> sortFieldIdList) {
		this.sortFieldIdList = sortFieldIdList;
	}
	
	public void addSortFieldIdList(String sortFieldId) {
		if(!MyUtils.isNotNull(sortFieldIdList)) {
			this.sortFieldIdList = new ArrayList<String>();
		}
		this.sortFieldIdList.add(sortFieldId);
	}

	public Integer getOrderDirection() {
		return orderDirection;
	}

	public void setOrderDirection(Integer orderDirection) {
		this.orderDirection = orderDirection;
	}

}
